local Widgets = _Avyr_GUI_Widgets_Lib
local MouseIsOver, insert = MouseIsOver, table.insert;
local BorderSize, Padding = Widgets.BorderSize, Widgets.Padding;

local function SetChecked(self, Value, UserInput)
    if self.State ~= Value then
        self.State = Value
        if Value then
            self.Checkbox:Backdrop("Backdrop", 1, 0.82, 0)
        else
            self.Checkbox:Backdrop("Backdrop")
        end
        if self.OnChecked and UserInput then
            self.OnChecked(self, self.State)
        end
    end
end

Widgets.CreateCheckbox = function(self, Parent)
    local Checkbutton = Widgets:CreateFrame(Parent)

    Checkbutton.Checkbox = Widgets:CreateButton(Checkbutton)
    Checkbutton.Checkbox:SetPoint("TOPLEFT")
    Checkbutton.Checkbox:Size(20, 20)
    Checkbutton.Checkbox:Backdrop()
    Checkbutton.Checkbox.ActiveCheck = function()
        return not Checkbutton.Disable
    end

    Checkbutton.Checkbox.OnClick = function(self)
        if not Checkbutton.Disable then
            Checkbutton:SetChecked(not Checkbutton.State, true)
        end
    end

    Checkbutton:SetText("", 11, 1, 1, 1, "LEFT")
    Checkbutton.Text1:SetPoint("BOTTOMLEFT", BorderSize + Padding + Checkbutton.Checkbox:GetWidth(), BorderSize + Padding)

    Checkbutton.State = false;
    Checkbutton.SetChecked = SetChecked;

    Checkbutton.EnterLeave = function(self, Enter)
        if Enter then
            if self.Checkbox.State ~= "Pushed" and not self.Disable then
                self.Checkbox.State = "MouseOver"
                self.Checkbox:PresetBorders(self.Checkbox.State)
            end
        else
            if self.Checkbox.State ~= "Pushed" and not self.Disable then
                self.Checkbox.State = "Normal"
                self.Checkbox:PresetBorders(self.Checkbox.State)
            end
        end
    end

    Checkbutton.MouseInteraction = function(self, Up)
        if Up then
            if not self.Disable then
                if MouseIsOver(self) then
                    self.Checkbox.State = "MouseOver"
                    self.Checkbox:PresetBorders(self.Checkbox.State)
                    self:SetChecked(not Checkbutton.State, true)
                else
                    self.Checkbox:Backdrop("Border")
                    self.Checkbox.State = "Normal"
                    self.Checkbox:PresetBorders(self.Checkbox.State)
                end
            end
        else
            if not self.Disable then
                self.Checkbox.State = "Pushed"
                self.Checkbox:PresetBorders(self.Checkbox.State)
            end
        end
    end
    Checkbutton:MakeInteractable(true);

    insert(Checkbutton.LM, "Checkbox")
    insert(Checkbutton.LM, "State")
    insert(Checkbutton.LM, "SetChecked")
    insert(Checkbutton.LM, "OnChecked")

    return Checkbutton
end
